/*
to read a list of addresses or names and hunt TM.LOG to see when they
were last on, or not.
*/

#include <stdio.h>
//#include <alloc.h>
#include <stdlib.h>
#include <dos.h>
#include <ctype.h>
#include <string.h>

char *rmtrail(char *lin);

int main(int argc, char *argv[])
{
FILE *log, *out, *cfg;
char line[200];
char name[1000][40];//=NULL;
char result[1000][40];//=NULL;
int namecnt=0,junk;
int offset=14;
char firstline[20];
signed char month,domonth=0;
struct date d;
int day,mon;

printf("When-On. (Freeware by Simon Avery 1999)\n");

getdate(&d);
month=d.da_mon;

if (argc < 3)
	{
	printf("Usage:\nWHEN-ON cfg_file log_file out_file {month}\n");
	return 1;
	}

if (argc==5)
	{
//	offset=atoi(argv[4]);	// not doing that, using month instead
	month=atoi(argv[4]);
	junk=month;
	domonth=1;

	if (month==0)	month=d.da_mon;
	if (month<0)	month=(d.da_mon + junk); // plus, not minus as it's a negative value

	if (month < 1)	month=12;

	printf("Only checking month #%d\n",month);
	}

if ((cfg=fopen(argv[1],"rt"))==NULL)
	{
	printf("Cannot open cfg_file: %s\n",argv[1]);
	return 2;
	}
if ((log=fopen(argv[2],"rt"))==NULL)
	{
	printf("Cannot open log_file: %s\n",argv[2]);
	return 2;
	}
if ((out=fopen(argv[3],"wt"))==NULL)
	{
	printf("Cannot open out_file: %s\n",argv[3]);
	return 2;
	}


while(fgets(line,200,cfg))
	{
	if (line[0]!=';')
		{
		rmtrail(line);
		strcpy(name[namecnt],line);
		namecnt++;
		}
	}
fclose(cfg);
printf("%d config entries read from %s\n",namecnt,argv[1]);

//for (junk=0; junk!=namecnt; junk++)		printf("Entry %d: [%s]\n",junk,name[junk]);

for (junk=0; junk!=namecnt; junk++)		strcpy((char *)result[junk],"Not Found");

printf("Reading %s...\n",argv[2]);

fgets(line,200,log);
fgets(line,200,log);
fgets(line,200,log);
line[15]=0;
strcpy(firstline,line);

while(fgets(line,200,log))
	{
	for (junk=0; junk!=namecnt; junk++)
		{
		if ((strstr(line,name[junk])) && (strstr(line,"using")))	// need to check tfor that to stop it triggering on mailscan
			{
			line[39]=0;
			line[offset]=0;
			if (domonth)
				{
				sscanf(line,"%d/%d",&day,&mon);
				if (mon==month)
					{
					strcpy(result[junk],line);
					}
				}
				else
				{
				strcpy(result[junk],line);
				}

			}
		}
	}

fclose(log);
printf("Parsing.\n");

fprintf(out,"When-On created this file, based on the logfile: %s\n",strupr(argv[2]));
fprintf(out,"First date in logfile: %s\n\n",firstline);

for (junk=0; junk!=namecnt; junk++)
	{
	fprintf(out,"%-30s%s\n",name[junk],result[junk]);
	printf("%-30s%s\n",name[junk],result[junk]);
	}

fprintf(out,"\n\n--- When-On\n");

fclose(out);
return 0;
}

char *rmtrail(char *lin)
{
int jnk;

jnk=strlen(lin);
while(jnk >= 0)
	{
	jnk--;
	if (!isspace(lin[jnk])) break;
	lin[jnk]=0;
	}
return lin;
}

